import fs from 'fs';
import path from 'path';

var filesToObject = function (_ref) {
  var folder = _ref.folder;
  var processName = _ref.processName;
  var processContent = _ref.processContent;
  var _ref$ignoreExt = _ref.ignoreExt;

  var obj = {};

  var files = fs.readdirSync(folder);

  files.forEach(function (file) {
    var basename = path.basename(file);
    var extension = path.extname(file);

    var fullPath = path.join(folder, basename);

    if (ignoreExt.indexOf(extension) >= 0) {
      return;
    }

    var name = processName && processName(basename, extension, fullPath) || basename;

    var stats = fs.statSync(path.resolve(process.cwd(), fullPath));

    if (stats.isDirectory()) {
      obj[name] = filesToObject({ folder: fullPath, processName: processName, processContent: processContent, ignoreExt: ignoreExt });
    } else {
      var content = processContent && processContent(basename, extension, fullPath) || null;
    }
  });

  return obj;
};

export default filesToObject;